元素的复制

在使用中,经常需要对 Benlety 中的对象进行克隆,以下进行总结。

Element 克隆

程序集 命名空间
Bentley.DgnPlatformNET.dll Bentley.DgnPlatformNET
1
2
3
4
5
6
7
8
9
10
11
12
//复制元素
using (ElementCopyContext cc = new ElementCopyContext(dgnModel))
{
cc.WriteElements = false; //调整复制上下文环境不要立即写入元素
Element _cloneEle = cc.DoCopy(_el);
ElementPropertiesSetter eps = new ElementPropertiesSetter();
eps.SetColor(lineColor);
eps.SetWeight(LineWeight);
eps.Apply(_cloneEle); //设置颜色
_cloneEle.AddToModel();
return _cloneEle;
}

SolidKernelEntity 克隆

程序集 命名空间
Bentley.DgnDisplayNet.dll Bentley.DgnPlatformNET
1
2
// 复制 SolidKernelEntity
CopyEntity(out SolidKernelEntity entityOut, SolidKernelEntity entityIn)

CurveVector 克隆

调用对象的 Clone() 方法。